/*************************************************************************/ /*!
@File           sysconfig.h
@Title          System Configuration
@Copyright      Copyright (c) Innosilicon Technology Ltd. All Rights Reserved
@Description    System Configuration functions
@License        Dual MIT/GPLv2

The contents of this file are subject to the MIT license as set out below.

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

Alternatively, the contents of this file may be used under the terms of
the GNU General Public License Version 2 ("GPL") in which case the provisions
of GPL are applicable instead of those above.

If you wish to allow use of your version of this file only under the terms of
GPL, and not to allow others to use your version of this file under the terms
of the MIT license, indicate your decision by deleting the provisions above
and replace them with the notice and other provisions required by GPL as set
out in the file called "GPL-COPYING" included in this distribution. If you do
not delete the provisions above, a recipient may use your version of this file
under the terms of either the MIT license or GPL.

This License is also included in this distribution in the file called
"MIT-COPYING".

EXCEPT AS OTHERWISE STATED IN A NEGOTIATED AGREEMENT: (A) THE SOFTWARE IS
PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT; AND (B) IN NO EVENT SHALL THE AUTHORS OR
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/ /**************************************************************************/

#ifndef __INNOGPU_DEFS_H__
#define __INNOGPU_DEFS_H__

/* innogpu chip info */
#define INNOGPU_INFO_IDX_START                    (0x0)
#define INNOGPU_INFO_DEVICE_ID                    (INNOGPU_INFO_IDX_START + 1)
#define INNOGPU_INFO_SPU_NUM                      (INNOGPU_INFO_IDX_START + 2)
#define INNOGPU_INFO_CLUSTERS_NUM                 (INNOGPU_INFO_IDX_START + 3)
#define INNOGPU_INFO_SPU1_CLUSTERS                (INNOGPU_INFO_IDX_START + 4)
#define INNOGPU_INFO_TPU_BUFFER_LOOKUP_SIZE_KB    (INNOGPU_INFO_IDX_START + 5)
#define INNOGPU_INFO_SGL_MAX_TEXTURE_BUFFER_SIZE  (INNOGPU_INFO_IDX_START + 6)
#define INNOGPU_INFO_GLES_MAX_TEXTURE_BUFFER_SIZE (INNOGPU_INFO_IDX_START + 7)
#define INNOGPU_INFO_IDX_END                      (INNOGPU_INFO_IDX_START + 8)

#endif /* __INNOGPU_INFO_DEFS_H__ */
