#ifndef KGC_GPU_INFO_H
#define KGC_GPU_INFO_H
#include <linux/miscdevice.h>
#include "inno_plat_dev.h"


struct kgc_item{
	unsigned int cmd;
	void (*func)(void *chip_ctx, void *args);
};

struct plugin_miscdev{
	int open_flag;
	inno_dev * pdev;
	struct miscdevice misc_dev;
	int gpu_plugin_minor;
};

enum gpu_base_info{
	GPU_BASE_INFO_VENDOR_NAME,
	GPU_BASE_INFO_CARD_NAME,
	GPU_BASE_INFO_GPU_NAME,
	GPU_BASE_INFO_GPU_CLOCK,
	GPU_BASE_INFO_VRAM_CLOCK,
	GPU_BASE_INFO_MAX_GPU_CLOCK,
	GPU_BASE_INFO_MAX_VRAM_CLOCK,
	GPU_BASE_INFO_PCI_SPEED,
	GPU_BASE_INFO_PCI_WIDTH,
	GPU_BASE_INFO_MAX_LINK_SPEED,
	GPU_BASE_INFO_MAX_LINK_WIDTH,
	GPU_BASE_INFO_PCI_BUS_ID,
	GPU_BASE_INFO_PCI_INFO,
	GPU_BASE_INFO_GPU_TEMP,
	GPU_BASE_INFO_FAN_SPEED,
	GPU_BASE_INFO_VRAM_TYPE,
	GPU_BASE_INFO_VRAM_SIZE,
	GPU_BASE_INFO_VRAM_LOAD,
	GPU_BASE_INFO_VRAM_USED,
	GPU_BASE_INFO_GPU_LOAD,
	GPU_BASE_INFO_VIDEO_LOAD,
	GPU_BASE_INFO_VBIOS_VERSION,
	GPU_BASE_INFO_MANUFACTURER,
	GPU_BASE_INFO_SHADER_NUMBER,
	GPU_BASE_INFO_GPU_VDDC,
	GPU_BASE_INFO_GPU_POWER,
	GPU_BASE_INFO_MAX_GPU_POWER,
	GPU_BASE_INFO_POWER_MODE,
	GPU_BASE_INFO_POWER_MODE_LIST
};

#define GPU_BASE_INFO_IOCTL_MAGIC  'P'
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_VENDOR_NAME        _IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_VENDOR_NAME)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_CARD_NAME          _IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_CARD_NAME)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_GPU_NAME		      _IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_GPU_NAME)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_GPU_CLOCK		    _IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_GPU_CLOCK)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_VRAM_CLOCK	        _IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_VRAM_CLOCK)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_MAX_GPU_CLOCK	    _IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_MAX_GPU_CLOCK)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_MAX_VRAM_CLOCK	    _IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_MAX_VRAM_CLOCK)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_PCI_SPEED            _IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_PCI_SPEED)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_PCI_WIDTH			_IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_PCI_WIDTH)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_MAX_LINK_SPEED	    _IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_MAX_LINK_SPEED)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_MAX_LINK_WIDTH	    _IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_MAX_LINK_WIDTH)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_PCI_BUS_ID           _IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_PCI_BUS_ID)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_PCI_INFO             _IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_PCI_INFO)

#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_GPU_TEMP			    _IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_GPU_TEMP)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_FAN_SPEED			_IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_FAN_SPEED)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_VRAM_TYPE			_IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_VRAM_TYPE)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_VRAM_SIZE			_IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_VRAM_SIZE)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_VRAM_LOAD			_IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_VRAM_LOAD)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_VRAM_USED			_IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_VRAM_USED)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_GPU_LOAD			    _IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_GPU_LOAD)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_VIDEO_LOAD		    _IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_VIDEO_LOAD)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_VBIOS_VERSION		_IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_VBIOS_VERSION)

#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_MANUFACTURER		    _IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_MANUFACTURER)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_SHADER_NUMBER		_IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_SHADER_NUMBER)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_GPU_VDDC			    _IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_GPU_VDDC)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_GPU_POWER		    _IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_GPU_POWER)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_MAX_GPU_POWER		_IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_MAX_GPU_POWER)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_POWER_MODE		    _IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_POWER_MODE)
#define INNOGPU_GPU_INFO_GET_GPU_BASE_INFO_POWER_MODE_LIST	    _IO(GPU_BASE_INFO_IOCTL_MAGIC, GPU_BASE_INFO_POWER_MODE_LIST)
	
#define INNOGPU_GPU_INFO_IOCTL_GET(name)  (INNOGPU_GPU_INFO_GET_##name)




int sys_gpu_plugin_init(inno_dev *pdev);
void sys_gpu_plugin_exit(inno_dev *pdev);

#endif
